##// END OF EJS Templates
Recharge du master
vidal -
r721:42ab8d184275
parent child
Show More
@@ -1,902 +1,897
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47 if [ $RELEASE = "bullseye" ] ; then
48 48 RELEASE=testing
49 49 fi
50 50
51 51 # Kernel Branch
52 52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 53
54 54 # URLs
55 55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 64
65 65 # Kernel deb packages for 32bit kernel
66 66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
70 70 # Default precompiled 64bit kernel
71 71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
72 72 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 73 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
74 74 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 75 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
76 76 # Generic
77 77 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 78 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 79 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 80 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 81
82 82 # Build directories
83 83 WORKDIR=$(pwd)
84 84 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 85 BUILDDIR="${BASEDIR}/build"
86 86
87 87 # Chroot directories
88 88 R="${BUILDDIR}/chroot"
89 89 ETC_DIR="${R}/etc"
90 90 LIB_DIR="${R}/lib"
91 91 BOOT_DIR="${R}/boot/firmware"
92 92 KERNEL_DIR="${R}/usr/src/linux"
93 93 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 94 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 95
96 96 # Firmware directory: Blank if download from github
97 97 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
98 98
99 99 # General settings
100 100 SET_ARCH=${SET_ARCH:=32}
101 101 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
102 102 PASSWORD=${PASSWORD:=raspberry}
103 103 USER_PASSWORD=${USER_PASSWORD:=raspberry}
104 104 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
105 105 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
106 106 EXPANDROOT=${EXPANDROOT:=true}
107 107 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
108 108
109 109 # Keyboard settings
110 110 XKB_MODEL=${XKB_MODEL:=""}
111 111 XKB_LAYOUT=${XKB_LAYOUT:=""}
112 112 XKB_VARIANT=${XKB_VARIANT:=""}
113 113 XKB_OPTIONS=${XKB_OPTIONS:=""}
114 114
115 115 # Network settings (DHCP)
116 116 ENABLE_DHCP=${ENABLE_DHCP:=true}
117 117
118 118 # Network settings (static)
119 119 NET_ADDRESS=${NET_ADDRESS:=""}
120 120 NET_GATEWAY=${NET_GATEWAY:=""}
121 121 NET_DNS_1=${NET_DNS_1:=""}
122 122 NET_DNS_2=${NET_DNS_2:=""}
123 123 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
124 124 NET_NTP_1=${NET_NTP_1:=""}
125 125 NET_NTP_2=${NET_NTP_2:=""}
126 126
127 127 # APT settings
128 128 APT_PROXY=${APT_PROXY:=""}
129 129 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
130 130 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
131 131
132 132 # Feature settings
133 133 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
134 134 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
135 135 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
136 136 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
137 137 ENABLE_I2C=${ENABLE_I2C:=false}
138 138 ENABLE_SPI=${ENABLE_SPI:=false}
139 139 ENABLE_IPV6=${ENABLE_IPV6:=true}
140 140 ENABLE_SSHD=${ENABLE_SSHD:=true}
141 141 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
142 142 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
143 143 ENABLE_SOUND=${ENABLE_SOUND:=true}
144 144 ENABLE_DBUS=${ENABLE_DBUS:=true}
145 145 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
146 146 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
147 147 ENABLE_XORG=${ENABLE_XORG:=false}
148 148 ENABLE_WM=${ENABLE_WM:=""}
149 149 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
150 150 ENABLE_USER=${ENABLE_USER:=true}
151 151 USER_NAME=${USER_NAME:="pi"}
152 152 ENABLE_ROOT=${ENABLE_ROOT:=false}
153 153 ENABLE_QEMU=${ENABLE_QEMU:=false}
154 154 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
155 155
156 156 # SSH settings
157 157 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
158 158 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
159 159 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
160 160 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
161 161 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
162 162
163 163 # Advanced settings
164 164 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
165 165 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
166 166 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
167 167 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
168 168 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
169 169 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
170 170 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
171 171 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
172 172 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
173 173 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
174 174 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
175 175 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
176 176 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
177 177 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
178 178 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
179 179 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
180 180 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
181 181 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
182 182 ENABLE_LOGO=${ENABLE_LOGO:=true}
183 183 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
184 184 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
185 185
186 186 # Kernel compilation settings
187 187 BUILD_KERNEL=${BUILD_KERNEL:=true}
188 188 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
189 189 KERNEL_THREADS=${KERNEL_THREADS:=1}
190 190 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
191 191 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
192 192 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
193 193 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
194 194 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
195 195 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
196 196 KERNEL_VIRT=${KERNEL_VIRT:=false}
197 197 KERNEL_BPF=${KERNEL_BPF:=false}
198 198 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
199 199 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
200 200 KERNEL_NF=${KERNEL_NF:=false}
201 201 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
202 202 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
203 203 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
204 204 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
205 205
206 206 # Kernel compilation from source directory settings
207 207 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
208 208 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
209 209 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
210 210 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
211 211
212 212 # Reduce disk usage settings
213 213 REDUCE_APT=${REDUCE_APT:=true}
214 214 REDUCE_DOC=${REDUCE_DOC:=true}
215 215 REDUCE_MAN=${REDUCE_MAN:=true}
216 216 REDUCE_VIM=${REDUCE_VIM:=false}
217 217 REDUCE_BASH=${REDUCE_BASH:=false}
218 218 REDUCE_HWDB=${REDUCE_HWDB:=true}
219 219 REDUCE_SSHD=${REDUCE_SSHD:=true}
220 220 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
221 221
222 222 # Encrypted filesystem settings
223 223 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
224 224 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
225 225 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
226 226 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
227 227 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
228 228 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
229 229 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
230 230 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
231 231 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
232 232 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
233 233
234 234 # Chroot scripts directory
235 235 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
236 236
237 237 # Packages required in the chroot build environment
238 238 APT_INCLUDES=${APT_INCLUDES:=""}
239
240 239 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
241 240
242 241 # Packages to exclude from chroot build environment
243 242 APT_EXCLUDES=${APT_EXCLUDES:=""}
244 243
245 244 # Packages required for bootstrapping
246
247 245 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
248 246 MISSING_PACKAGES=""
249 247
250 248 # Packages installed for c/c++ build environment in chroot (keep empty)
251 249 COMPILER_PACKAGES=""
252 250
253 251 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
254 252 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
255 253 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
256 254 APT_PROXY=http://127.0.0.1:3142/
257 255 fi
258 256
259 257 # Setup architecture specific settings
260 258 if [ -n "$SET_ARCH" ] ; then
261 259 # 64-bit configuration
262 260 if [ "$SET_ARCH" = 64 ] ; then
263 261 # General 64-bit depended settings
264 262 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
265 263 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
266 264 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
267 265
268 266 # Raspberry Pi model specific settings
269 267 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
270 268 if [ "$RPI_MODEL" != 4 ] ; then
271 269 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
272 270 else
273 271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
274 272 fi
275 273
276 274 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
277 275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
278 276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
279 277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
280 278 else
281 279 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
282 280 exit 1
283 281 fi
284 282 fi
285 283
286 284 # 32-bit configuration
287 285 if [ "$SET_ARCH" = 32 ] ; then
288 286 # General 32-bit dependend settings
289 287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
290 288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
291 289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
292 290
293 291 # Raspberry Pi model specific settings
294 292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
295 293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
296 294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
297 295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
298 296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
299 297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
300 298 fi
301 299
302 300 # Raspberry Pi model specific settings
303 301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
304 302 if [ "$RPI_MODEL" != 4 ] ; then
305 303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
306 304 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
307 305 else
308 306 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
309 307 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
310 308 fi
311 309
312 310 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
313 311 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
314 312
315 313 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
316 314 fi
317 315 fi
318 316 # SET_ARCH not set
319 317 else
320 318 echo "error: Please set '32' or '64' as value for SET_ARCH"
321 319 exit 1
322 320 fi
323 321 # Device specific configuration and U-Boot configuration
324 322 case "$RPI_MODEL" in
325 323 0)
326 324 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
327 325 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
328 326 ;;
329 327 1)
330 328 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
331 329 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
332 330 ;;
333 331 1P)
334 332 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
335 333 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
336 334 ;;
337 335 2)
338 336 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
339 337 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
340 338 ;;
341 339 3)
342 340 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
343 341 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
344 342 ;;
345 343 3P)
346 344 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
347 345 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
348 346 ;;
349 347 4)
350 348 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
351 349 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
352 350 ;;
353 351 *)
354 352 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
355 353 exit 1
356 354 ;;
357 355 esac
358 356
359 357 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
360 358 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
361 359 # Include bluetooth packages on supported boards
362 360 if [ "$ENABLE_BLUETOOTH" = true ] ; then
363 361 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
364 362 fi
365 363 if [ "$ENABLE_WIRELESS" = true ] ; then
366 364 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
367 365 fi
368 366 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
369 367 # Check if the internal wireless interface is not supported by the RPi model
370 368 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
371 369 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
372 370 exit 1
373 371 fi
374 372 fi
375 373
376 374 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
377 375 echo "error: You have to compile kernel sources, if you want to enable nexmon"
378 376 exit 1
379 377 fi
380 378
381 379 # Prepare date string for default image file name
382 380 DATE="$(date +%Y-%m-%d)"
383 381 if [ -z "$KERNEL_BRANCH" ] ; then
384 382 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
385 383 else
386 384 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
387 385 fi
388 386
389 387 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
390 388 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
391 389 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
392 390 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
393 391 exit 1
394 392 fi
395 393 fi
396 394
397 395 # Add cmake to compile videocore sources
398 396 if [ "$ENABLE_VIDEOCORE" = true ] ; then
399 397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
400 398 fi
401 399
402 400 # Add deps for nexmon
403 401 if [ "$ENABLE_NEXMON" = true ] ; then
404
405 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
406 403 fi
407 404
408 405 # Add libncurses5 to enable kernel menuconfig
409 406 if [ "$KERNEL_MENUCONFIG" = true ] ; then
410 407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
411 408 fi
412 409
413 410 # Add ccache compiler cache for (faster) kernel cross (re)compilation
414 411 if [ "$KERNEL_CCACHE" = true ] ; then
415 412 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
416 413 fi
417 414
418 415 # Add cryptsetup package to enable filesystem encryption
419 416 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
420 417 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
421
422 418 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
423 419
424 420 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
425 421 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
426 422 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
427 423 fi
428 424
429 425 if [ -z "$CRYPTFS_PASSWORD" ] ; then
430 426 echo "error: no password defined (CRYPTFS_PASSWORD)!"
431 427 exit 1
432 428 fi
433 429 ENABLE_INITRAMFS=true
434 430 fi
435 431
436 432 # Add initramfs generation tools
437 433 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
438 434 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
439 435 fi
440 436
441 437 # Add device-tree-compiler required for building the U-Boot bootloader
442 438 if [ "$ENABLE_UBOOT" = true ] ; then
443 439 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
444 440 fi
445 441
446 442 if [ "$ENABLE_USBBOOT" = true ] ; then
447 443 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
448 444 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
449 445 exit 1
450 446 fi
451 447 fi
452 448
453 449 # Check if root SSH (v2) public key file exists
454 450 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
455 451 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
456 452 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
457 453 exit 1
458 454 fi
459 455 fi
460 456
461 457 # Check if $USER_NAME SSH (v2) public key file exists
462 458 if [ -n "$SSH_USER_PUB_KEY" ] ; then
463 459 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
464 460 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
465 461 exit 1
466 462 fi
467 463 fi
468 464
469 465 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
470 466 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
471 467 exit 1
472 468 fi
473 469
474 470 # Check if all required packages are installed on the build system
475 471 for package in $REQUIRED_PACKAGES ; do
476 472 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
477 473 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
478 474 fi
479 475 done
480 476
481 477 # If there are missing packages ask confirmation for install, or exit
482 478 if [ -n "$MISSING_PACKAGES" ] ; then
483 479 echo "the following packages needed by this script are not installed:"
484 480 echo "$MISSING_PACKAGES"
485 481
486 482 printf "\ndo you want to install the missing packages right now? [y/n] "
487 483 read -r confirm
488 484 [ "$confirm" != "y" ] && exit 1
489 485
490 486 # Make sure all missing required packages are installed
491 487 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
492 488 fi
493 489
494 490 # Check if ./bootstrap.d directory exists
495 491 if [ ! -d "./bootstrap.d/" ] ; then
496 492 echo "error: './bootstrap.d' required directory not found!"
497 493 exit 1
498 494 fi
499 495
500 496 # Check if ./files directory exists
501 497 if [ ! -d "./files/" ] ; then
502 498 echo "error: './files' required directory not found!"
503 499 exit 1
504 500 fi
505 501
506 502 # Check if specified KERNELSRC_DIR directory exists
507 503 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
508 504 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
509 505 exit 1
510 506 fi
511 507
512 508 # Check if specified UBOOTSRC_DIR directory exists
513 509 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
514 510 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
515 511 exit 1
516 512 fi
517 513
518 514 # Check if specified VIDEOCORESRC_DIR directory exists
519 515 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
520 516 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
521 517 exit 1
522 518 fi
523 519
524 520 # Check if specified FBTURBOSRC_DIR directory exists
525 521 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
526 522 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
527 523 exit 1
528 524 fi
529 525
530 526 # Check if specified NEXMONSRC_DIR directory exists
531 527 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
532 528 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
533 529 exit 1
534 530 fi
535 531
536 532 # Check if specified CHROOT_SCRIPTS directory exists
537 533 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
538 534 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
539 535 exit 1
540 536 fi
541 537
542 538 # Check if specified device mapping already exists (will be used by cryptsetup)
543 539 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
544 540 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
545 541 exit 1
546 542 fi
547 543
548 544 # Don't clobber an old build
549 545 if [ -e "$BUILDDIR" ] ; then
550 546 echo "error: directory ${BUILDDIR} already exists, not proceeding"
551 547 exit 1
552 548 fi
553 549
554 550 # Setup chroot directory
555 551 mkdir -p "${R}"
556 552
557 553 # Check if build directory has enough of free disk space >512MB
558 554 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
559 555 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
560 556 exit 1
561 557 fi
562 558
563 559 set -x
564 560
565 561 # Call "cleanup" function on various signals and errors
566 562 trap cleanup 0 1 2 3 6
567 563
568 564 # Add required packages for the minbase installation
569 565 if [ "$ENABLE_MINBASE" = true ] ; then
570 566 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
571 567 fi
572 568
573 569 # Add parted package, required to get partprobe utility
574 570 if [ "$EXPANDROOT" = true ] ; then
575 571 APT_INCLUDES="${APT_INCLUDES},parted"
576 572 fi
577 573
578 574 # Add dphys-swapfile package, required to enable swap
579 575 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
580 576 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
581 577 fi
582 578
583 579 # Add dbus package, recommended if using systemd
584 580 if [ "$ENABLE_DBUS" = true ] ; then
585 581 APT_INCLUDES="${APT_INCLUDES},dbus"
586 582 fi
587 583
588 584 # Add iptables IPv4/IPv6 package
589 585 if [ "$ENABLE_IPTABLES" = true ] ; then
590 586 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
591 587 fi
592 588 # Add apparmor for KERNEL_SECURITY
593 589 if [ "$KERNEL_SECURITY" = true ] ; then
594 590 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
595 591 fi
596 592
597 593 # Add openssh server package
598 594 if [ "$ENABLE_SSHD" = true ] ; then
599 595 APT_INCLUDES="${APT_INCLUDES},openssh-server"
600 596 fi
601 597
602 598 # Add alsa-utils package
603 599 if [ "$ENABLE_SOUND" = true ] ; then
604 600 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
605 601 fi
606 602
607 603 # Add rng-tools package
608 604 if [ "$ENABLE_HWRANDOM" = true ] ; then
609 605 APT_INCLUDES="${APT_INCLUDES},rng-tools"
610 606 fi
611 607
612 608 # Add fbturbo video driver
613 609 if [ "$ENABLE_FBTURBO" = true ] ; then
614 610 # Enable xorg package dependencies
615 611 ENABLE_XORG=true
616 612 fi
617 613
618 614 # Add user defined window manager package
619 615 if [ -n "$ENABLE_WM" ] ; then
620 616 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
621 617
622 618 # Enable xorg package dependencies
623 619 ENABLE_XORG=true
624 620 fi
625 621
626 622 # Add xorg package
627 623 if [ "$ENABLE_XORG" = true ] ; then
628 624 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
629 625 fi
630 626
631 627 # Replace selected packages with smaller clones
632 628 if [ "$ENABLE_REDUCE" = true ] ; then
633 629 # Add levee package instead of vim-tiny
634 630 if [ "$REDUCE_VIM" = true ] ; then
635 631 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
636 632 fi
637 633
638 634 # Add dropbear package instead of openssh-server
639 635 if [ "$REDUCE_SSHD" = true ] ; then
640 636 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
641 637 fi
642 638 fi
643 639
644 640 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
645 641 if [ "$ENABLE_SYSVINIT" = false ] ; then
646 642 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
647 643 fi
648 644
649 645 # Configure kernel sources if no KERNELSRC_DIR
650 646 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
651 647 KERNELSRC_CONFIG=true
652 648 fi
653 649
654 650 # Configure reduced kernel
655 651 if [ "$KERNEL_REDUCE" = true ] ; then
656 652 KERNELSRC_CONFIG=false
657 653 fi
658 654
659 655 # Configure qemu compatible kernel
660 656 if [ "$ENABLE_QEMU" = true ] ; then
661 657 DTB_FILE=vexpress-v2p-ca15_a7.dtb
662 658 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
663 659 KERNEL_DEFCONFIG="vexpress_defconfig"
664 660 if [ "$KERNEL_MENUCONFIG" = false ] ; then
665 661 KERNEL_OLDDEFCONFIG=true
666 662 fi
667 663 fi
668 664
669 665 # Execute bootstrap scripts
670 666 for SCRIPT in bootstrap.d/*.sh; do
671 667 head -n 3 "$SCRIPT"
672 668 . "$SCRIPT"
673 669 done
674 670
675 671 ## Execute custom bootstrap scripts
676 672 if [ -d "custom.d" ] ; then
677 673 for SCRIPT in custom.d/*.sh; do
678 674 . "$SCRIPT"
679 675 done
680 676 fi
681 677
682 678 # Execute custom scripts inside the chroot
683 679 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
684 680 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
685 681 chroot_exec /bin/bash -x <<'EOF'
686 682 for SCRIPT in /chroot_scripts/* ; do
687 683 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
688 684 $SCRIPT
689 685 fi
690 686 done
691 687 EOF
692 688 rm -rf "${R}/chroot_scripts"
693 689 fi
694 690
695 691 # Remove c/c++ build environment from the chroot
696 692 chroot_remove_cc
697 693
698 694 # Generate required machine-id
699 695 MACHINE_ID=$(dbus-uuidgen)
700 696 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
701 697 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
702 698
703 699 # APT Cleanup
704 700 chroot_exec apt-get -y clean
705 701 chroot_exec apt-get -y autoclean
706 702 chroot_exec apt-get -y autoremove
707 703
708 704 # Unmount mounted filesystems
709 705 umount -l "${R}/proc"
710 706 umount -l "${R}/sys"
711 707
712 708 # Clean up directories
713 709 rm -rf "${R}/run/*"
714 710 rm -rf "${R}/tmp/*"
715 711
716 712 # Clean up APT proxy settings
717 713 if [ "$KEEP_APT_PROXY" = false ] ; then
718 714 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
719 715 fi
720 716
721 717 # Clean up files
722 718 rm -f "${ETC_DIR}/ssh/ssh_host_*"
723 719 rm -f "${ETC_DIR}/dropbear/dropbear_*"
724 720 rm -f "${ETC_DIR}/apt/sources.list.save"
725 721 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
726 722 rm -f "${ETC_DIR}/*-"
727 723 rm -f "${ETC_DIR}/resolv.conf"
728 724 rm -f "${R}/root/.bash_history"
729 725 rm -f "${R}/var/lib/urandom/random-seed"
730 726 rm -f "${R}/initrd.img"
731 727 rm -f "${R}/vmlinuz"
732 728 rm -f "${R}${QEMU_BINARY}"
733 729
734 730 if [ "$ENABLE_QEMU" = true ] ; then
735 731 # Setup QEMU directory
736 732 mkdir "${BASEDIR}/qemu"
737 733
738 734 # Copy kernel image to QEMU directory
739 735 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
740 736
741 737 # Copy kernel config to QEMU directory
742 738 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
743 739
744 740 # Copy kernel dtbs to QEMU directory
745 741 for dtb in "${BOOT_DIR}/"*.dtb ; do
746 742 if [ -f "${dtb}" ] ; then
747 743 install_readonly "${dtb}" "${BASEDIR}/qemu/"
748 744 fi
749 745 done
750 746
751 747 # Copy kernel overlays to QEMU directory
752 748 if [ -d "${BOOT_DIR}/overlays" ] ; then
753 749 # Setup overlays dtbs directory
754 750 mkdir "${BASEDIR}/qemu/overlays"
755 751
756 752 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
757 753 if [ -f "${dtb}" ] ; then
758 754 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
759 755 fi
760 756 done
761 757 fi
762 758
763 759 # Copy u-boot files to QEMU directory
764 760 if [ "$ENABLE_UBOOT" = true ] ; then
765 761 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
766 762 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
767 763 fi
768 764 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
769 765 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
770 766 fi
771 767 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
772 768 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
773 769 fi
774 770 fi
775 771
776 772 # Copy initramfs to QEMU directory
777 773 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
778 774 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
779 775 fi
780 776 fi
781 777
782 778 # Calculate size of the chroot directory in KB
783 779 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
784 780
785 781 # Calculate the amount of needed 512 Byte sectors
786 782 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
787 783 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
788 784 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
789 785
790 786 # The root partition is EXT4
791 787 # This means more space than the actual used space of the chroot is used.
792 788 # As overhead for journaling and reserved blocks 35% are added.
793 789 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
794 790
795 791 # Calculate required image size in 512 Byte sectors
796 792 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
797 793
798 794 # Prepare image file
799 795 if [ "$ENABLE_SPLITFS" = true ] ; then
800 796 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
801 797 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
802 798 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
803 799 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
804 800
805 801 # Write firmware/boot partition tables
806 802 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
807 803 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
808 804 EOM
809 805
810 806 # Write root partition table
811 807 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
812 808 ${TABLE_SECTORS},${ROOT_SECTORS},83
813 809 EOM
814 810
815 811 # Setup temporary loop devices
816 812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
817 813 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
818 814 else # ENABLE_SPLITFS=false
819 815 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
820 816 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
821 817
822 818 # Write partition table
823 819 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
824 820 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
825 821 ${ROOT_OFFSET},${ROOT_SECTORS},83
826 822 EOM
827 823
828 824 # Setup temporary loop devices
829 825 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
830 826 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
831 827 fi
832 828
833 829 if [ "$ENABLE_CRYPTFS" = true ] ; then
834 830 # Create dummy ext4 fs
835 831 mkfs.ext4 "$ROOT_LOOP"
836 832
837 833 # Setup password keyfile
838 834 touch .password
839 835 chmod 600 .password
840 836 echo -n ${CRYPTFS_PASSWORD} > .password
841 837
842 838 # Initialize encrypted partition
843
844 839 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
845 840
846 841 # Open encrypted partition and setup mapping
847 842 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
848 843
849 844 # Secure delete password keyfile
850 845 shred -zu .password
851 846
852 847 # Update temporary loop device
853 848 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
854 849
855 850 # Wipe encrypted partition (encryption cipher is used for randomness)
856 851 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
857 852 fi
858 853
859 854 # Build filesystems
860 855 mkfs.vfat "$FRMW_LOOP"
861 856 mkfs.ext4 "$ROOT_LOOP"
862 857
863 858 # Mount the temporary loop devices
864 859 mkdir -p "$BUILDDIR/mount"
865 860 mount "$ROOT_LOOP" "$BUILDDIR/mount"
866 861
867 862 mkdir -p "$BUILDDIR/mount/boot/firmware"
868 863 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
869 864
870 865 # Copy all files from the chroot to the loop device mount point directory
871 866 rsync -a "${R}/" "$BUILDDIR/mount/"
872 867
873 868 # Unmount all temporary loop devices and mount points
874 869 cleanup
875 870
876 871 # Create block map file(s) of image(s)
877 872 if [ "$ENABLE_SPLITFS" = true ] ; then
878 873 # Create block map files for "bmaptool"
879 874 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
880 875 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
881 876
882 877 # Image was successfully created
883 878 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
884 879 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
885 880 else
886 881 # Create block map file for "bmaptool"
887 882 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
888 883
889 884 # Image was successfully created
890 885 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
891 886
892 887 # Create qemu qcow2 image
893 888 if [ "$ENABLE_QEMU" = true ] ; then
894 889 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
895 890 QEMU_SIZE=16G
896 891
897 892 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
898 893 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
899 894
900 895 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
901 896 fi
902 897 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant